unit fonctions_forms;
// Unité de la Version 2 du projet FormMain
// La version 1 TFormMain n'est pas sa fenêtre parente

// Le module crée des propriété servant à la gestion du fichier INI
// Il gère la déconnexion
// Il gère la gestion des touches majuscules et numlock
// Il gère les forms enfants
// créé par Matthieu Giroux en décembre 2007

{$I ..\DLCompilers.inc}
{$I ..\extends.inc}

interface

{$IFDEF FPC}
{$mode Delphi}
{$ENDIF}

uses
  {$IFDEF EADO}
     ADODB,
  {$ENDIF}
{$IFDEF VERSIONS}
  fonctions_version,
{$ENDIF}
{$IFDEF TNT}
  TNTForms,
{$ENDIF}
  SysUtils, Variants, Classes, Graphics, Controls, Forms,
{$IFDEF FPC}
  LCLIntf, LCLType,
{$ELSE}
  Windows, OleDb, Messages,
{$ENDIF}
  Dialogs, ExtCtrls, fonctions_ini;

{$IFDEF VERSIONS}
  const
    gVer_fonctions_forms : T_Version = (  Component : 'Gestion de Fenêtres' ;
                                       FileUnit : 'fonctions_forms' ;
                                       Owner : 'Matthieu Giroux' ;
                                       Comment : 'Fiche principale deuxième version.' ;
                                       BugsStory : '1.0.1.1 : Simplfying' +#13#10+
                                                   '1.0.1.0 : Resizing from OS' +#13#10+
                                                   '1.0.0.0 : Windows management from FormMainIni.';
                                       UnitType : 3 ;
                                       Major : 1 ; Minor : 0 ; Release : 1 ; Build : 1 );

{$ENDIF}

{$IFDEF FPC}
function ActiveMDIChild : TCustomForm;
procedure WindowMinimizeAll(Sender: TObject);
{$ENDIF}


function ffor_FindForm ( const as_FormNom : string ) : TCustomForm;
procedure p_CloseForm ( const as_FormNom : string );

function ffor_getForm   ( const as_FormNom, as_FormClasse : string  ): TForm; overload ;

function ffor_getForm   ( afor_FormClasse : TFormClass ): TForm; overload ;

var
  gb_ModalStarted : Boolean;


implementation

uses fonctions_proprietes, fonctions_erreurs, TypInfo,
  fonctions_system;

{ fonctions }


{------------------------------------------------------------------------------
 ---------------------- Fin Hook clavier pour le maj et le num ----------------
 ------------------------------------------------------------------------------}

    // Création d'une form MDI renvoie  la form qui existe
function ffor_FindForm ( const as_FormNom : string ) : TCustomForm;

var i : integer;
begin
  Result := nil;
  // Cette recherche ne fonctionne qu'avec les forms mdi child
  for i := 0 to Application.ComponentCount - 1 do
    if ( Application.Components [ i ] is TCustomForm )
    and ( Application.Components [ i ].Name = as_FormNom ) then
     Begin
      Result := Application.Components [ i ] as TCustomForm;
      Break;
     end;

end;

procedure p_CloseForm(const as_FormNom: string);
var
 lfor_Reference : TCustomForm;
begin
  lfor_Reference := ffor_FindForm ( as_FormNom );

  if lfor_Reference <> nil then
    lfor_Reference.Free;
end;


// Récupération d'une form renvoie la form si existe dans les enfants
// as_FormNom        : nom      de la form
// as_FormClasse   : classe   de la form
function ffor_getForm ( const as_FormNom, as_FormClasse: string ): TForm ;
var
  li_i: integer;

begin
  // Initialisation
  Result          := nil ;
//  if (FormStyle <> fsMDIForm) then
//    Exit;

  for li_i := Application.ComponentCount - 1 downto 0 do
    if (Application.Components[li_i] is TForm) and
       ( lowercase (( Application.Components[li_i] as TForm).ClassName ) = lowercase ( as_FormClasse )) then
      begin
        Result := TForm ( Application.Components[li_i] );
      end;
End ;

// Récupération d'une form renvoie la form si existe dans les enfants
// as_FormNom        : nom      de la form
// as_FormClasse   : classe   de la form
function ffor_getForm ( afor_FormClasse : TFormClass ): TForm;
var
  li_i: integer;

begin
  Result := nil ;
    // Recherche sûre de fiches quelconques
  For li_i := Application.ComponentCount - 1 downto 0
   do if (  Application.Components [ li_i ] is TForm )
     and (( Application.Components [ li_i ] as TForm ).ClassType = afor_FormClasse )
    Then
      Begin
        Result := TForm ( Application.Components [ li_i ] );
      End ;
End ;




{$IFDEF FPC}
procedure WindowMinimizeAll(Sender: TObject);
var li_i : Integer ;
Begin
  for li_i := 0 to Application.ComponentCount -1 do
    Begin
      If  ( Application.Components[ li_i ] <> Application.MainForm )
      and ( Application.Components[ li_i ] is TCustomForm ) Then
        ( Application.Components[ li_i ] as TCustomForm ).WindowState := wsMinimized;
    End ;
End;

function ActiveMDIChild : TCustomForm;
var li_i : Integer ;
Begin
  Result := Application.MainForm ;
  for li_i := 0 to Application.ComponentCount -1 do
    Begin
      If  ( Application.Components[ li_i ] <> Application.MainForm )
      and ( Application.Components[ li_i ] is TCustomForm )
      and (( Application.Components[ li_i ] as TCustomForm ).Active ) Then
        Result := Application.Components[ li_i ] as TCustomForm ;
    End ;
End;
{$ENDIF}



initialization
{$IFDEF VERSIONS}
  p_ConcatVersion ( gVer_fonctions_forms );
{$ENDIF}
end.
